GutsyRecipe

Differences between revisions 1 and 72 (spanning 71 versions)
Revision 1 as of 2008-01-11 13:03:07
Size: 3255
Editor: 26-191
Comment:
Revision 72 as of 2011-05-23 21:08:50
Size: 6353
Editor: cpc11-cdif12-2-0-cust1
Comment:
Deletions are marked like this. Additions are marked like this.
Line 1: Line 1:
THIS PAGE IS NOT FINISHED. DON'T FOLLOW ANY ADVISE IN IT UNTIL THIS LINE IS REMOVED. ## page was renamed from CalendarServerGutsyRecipe
## page was copied from CalendarServer
## page was renamed from CalDAVServer
/!\ ''' THIS PAGE IS NOT FINISHED. CONSIDER THE INSTRUCTIONS OF ALPHA RELEASE QUALITY. '''
 ''If you have any problems with any of the instructions here, please provide comment and feedback.''
 ''This page is a candidate for deletion.''
Line 4: Line 9:
This page will explain how to install Apple's iCal Server on Ubuntu Server, though desktop variants should also work without any problems. This page explains how to install Apple's [[http://en.wikipedia.org/wiki/Darwin_Calendar_Server|Darwin Calendar Server]] (also called DCS, and the basis for their iCal Server) on Ubuntu Gutsy.
Line 6: Line 11:
What is CalDAV?
Explain that here, together with an explanation between CalDAV and WebDAV/webcal, with a link to a page describing how to make that happen.
Line 9: Line 12:
Install procedure for Ubuntu Server 7.10 == Install procedure for Ubuntu Server 7.10 ==
Installing Apple's iCal Server is fairly trivial once you know what to do. You do need to download some additional packages using apt-get, and you'll need to download some software using subversion. Most users will be familiar with apt-get, many with subversion. If you're not familiar with subversion, don't panic. This guide will be a detailed, step by step howto, showing exactly which commands to enter and when.
Line 11: Line 15:
Installing Apple's iCal Server is fairly trivial once you know what to do. We do need to download some additional packages using apt-get, and we need to download some software using subversion. Most users will be familiar with apt-get, many with subversion. If you're not familiar with subversion, don't panic though. This guide will be a detailed, step by step howto, showing exactly which commands to enter and when. To make this work you will need to enable the Universe repositories (see [[AddingRepositoriesHowto]] and remember to do an {{{ apt-get update }}} afterwards).
Line 14: Line 18:
* Log into the server console or via ssh, so you can enter commands, and run sudo -s to get a root shell.
* Install subversion: apt-get install subversion
* Execute the following commands. It's ok to simply copy and paste them. It's quite alot of packages, and it may take a while for all of them to download and install.
Line 18: Line 19:
apt-get install libkrb5-dev
apt-get attr
apt-get install attr
apt-get install subversion
apt-get install curl
apt-get install build-essential
apt-get install libssl-dev
apt-get install python-pysqlite2
apt-get install bzip2
apt-get install curl
apt-get install zope3
apt-get install python-xml
apt-get install python-pyopenssl
apt-get install python-dateutil
apt-get install python-xattr
apt-get install python-pysqlite2
apt-get install python-twisted
apt-get install python-vobject
apt-get install python-kerberos
 * Log into the server console or via ssh, so you can enter commands, and run {{{ sudo -s }}} to get a root shell.
 * Install some software:
 {{{ apt-get install subversion libkrb5-dev attr curl build-essential libssl-dev python-pysqlite2 bzip2 }}}
 * Install some more software:
 {{{ apt-get install curl zope3 python-xml python-pyopenssl python-dateutil python-xattr python-pysqlite2 python-twisted python-vobject python-kerberos python-dev }}}
 * We now need to edit our /etc/fstab file and add {{{ user_xattr }}} to the options for the partition containing the CalDAV server, / in this case: {{{ vim /etc/fstab }}}
Line 38: Line 26:
* We now need to edit our /etc/fstab file and add user_xattr to the partition containing the CalDAV server, / in this case. vim /etc/fstab.
My / before edit: UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro 0 1
After edit: UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro,user_xattr 0 1
 This is what the /etc/fstab change looks like:
 {{{
 Before: UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro 0 1
After : UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro,user_xattr 0 1 }}}
Line 42: Line 31:
* We must now remount the filesystem: mount -o remount /
* Make a directory for the server in /opt:
mkdir /opt/iCalServer
* Let's download the server software itself using subversion:
svn checkout http://svn.macosforge.org/repository/calendarserver/CalendarServer/trunk CalendarServer
* Subversion created a directory for us, called CalendarServer. Let's change into it: cd CalendarServer
* And run a script to download some necessary packages, etc: ./run -s
* Ok. (Unless something is wrong and you got alot of errors, in which case, it's not ok) Our CalDAV server is almost ready for action. Let's copy the test configuration so we can get up as quickly as possible. Real configuration can wait:
cp conf/caldavd-test.plist conf/caldavd-dev.plist
* We do need to do some configuration though: vim conf/caldavd-test.plist

ADD PRECISE DESCRIPTION OF NECESSARY EDIT FOR EXTERNAL CONNECTIONS AND FOR EVOLUTION USERS!
 * Remount the file system (to activate user_xattr): {{{ mount -o remount / }}}
 * Create a director
y for our server to live in; {{{ mkdir /opt/caldavd }}}
 * and change into it, {{{ cd /opt/caldavd }}}
 
* Let's download the server software itself using subversion:
 {{{ svn checkout http://svn.macosforge.org/repository/calendarserver/CalendarServer/trunk CalendarServer }}}
 * Subversion has downloaded a lot of software, and created a directory for us, called CalendarServer. Let's change into it: {{{ cd CalendarServer }}}
 * And run a script to download some necessary packages, configure, etc: {{{ ./run -s }}}
 * Our CalDAV server is almost ready for action. Let's copy the test configuration so we can get it up as quickly as possible. Real configuration can wait: {{{ cp conf/caldavd-test.plist conf/caldavd-dev.plist }}}
 * We do need to do a little configuration though: {{{ vi conf/caldavd-dev.plist }}}
Line 55: Line 42:
   * First change the hostname for the server. Locate the line {{{ <!-- Network host name --> }}} and change {{{ <string>localhost</string> }}} to {{{ <string>your-real-hostname</string> }}} (That is, put the actual name of your server inside the string, it's used within URLs within the software.)
 * To make the server available to connections from other computers. Locate this line: {{{ <!-- List of IP addresses to bind to [empty = all] --> }}} and replace {{{ 127.0.0.1 }}} in {{{ <string>127.0.0.1</string> }}} with either nothing or a specific, public ip address for your server.
Line 58: Line 46:
References:
Cam's blog: http://cam.moobox.org/blog/?p=5
Lenfis blog:http://blog.jl42.de/index.php?/archives/231-Installation-of-the-Apple-Calendar-Server-on-Ubuntu-Edgy.html
http://trac.macosforge.org/projects/calendarserver/wiki/

 * Create a user and group to give our server an identity of its own, but we don't need a home directory for it; {{{ adduser --system --group caldavd --no-create-home }}}

 * Set permissions; {{{ chown -R caldavd:caldavd /opt/caldavd }}}

 * Run the server: {{{ sudo -u caldavd -b /opt/caldavd/CalendarServer/run }}}


That's it! The server is up and running, and you can connect to it with your CalDAV client using {{{ caldav://ADDRESS:8008/calendars/users/admin/calendar }}} to test the server using username {{{ admin }}} and password {{{ admin }}}

To work with Apple iCal under Mac OS 10.5, the URI required was simply: {{{ caldav://ADDRESS:8008 }}}


We want our CalendarServer to start up when our server starts up.
Thatfor we write a little startup script:

{{{/etc/init.d/caldavd}}}
{{{#! /bin/sh
#! /bin/sh

. /lib/lsb/init-functions

CALDAVD="/opt/caldavd/CalendarServer/run"
CALDAVD_USER="caldavd"
CALDAVD_OPTS="-d"
PIDFILE="/opt/caldavd/CalendarServer/logs/caldavd.pid"
NAME=caldavd

test -x $CALDAVD || exit 0

case "$1" in
  start)
        log_daemon_msg "Starting Darwin Calendar Server" "$NAME"
        if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --chuid $CALDAVD_USER --exec $CALDAVD -- $CALDAVD_OPTS; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  stop)
        log_daemon_msg "Stopping Darwin Calendar Server" "$NAME"
        if start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  restart)
        log_daemon_msg "Restarting Darwin Calendar Server" "$NAME"
        start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile $PIDFILE
        if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --chuid $CALDAVD_USER --exec $CALDAVD -- $CALDAVD_OPTS; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  status)
        status_of_proc -p "$CALDAVD" "$NAME" && exit 0 || exit $?
        ;;
  *)
        log_action_msg "Usage: /etc/init.d/caldavd {start|stop|restart|status}"
        exit 1
esac

exit 0
}}}

And to get it to load on boot and shutdown safely:
{{{
update-rc.d caldavd defaults
}}}

== To Do: ==
We also need to set up users and permissions for the server itself, so people can connect to the server and share their calendars, which is what we've been aiming for.

We should also document where the server-data is stored, so the information that users have entrusted to the server can be backed up.

Ideally we should package this application so the installation is installable with a single command.

Warning /!\ THIS PAGE IS NOT FINISHED. CONSIDER THE INSTRUCTIONS OF ALPHA RELEASE QUALITY.

  • If you have any problems with any of the instructions here, please provide comment and feedback. This page is a candidate for deletion.

This page explains how to install Apple's Darwin Calendar Server (also called DCS, and the basis for their iCal Server) on Ubuntu Gutsy.

Install procedure for Ubuntu Server 7.10

Installing Apple's iCal Server is fairly trivial once you know what to do. You do need to download some additional packages using apt-get, and you'll need to download some software using subversion. Most users will be familiar with apt-get, many with subversion. If you're not familiar with subversion, don't panic. This guide will be a detailed, step by step howto, showing exactly which commands to enter and when.

To make this work you will need to enable the Universe repositories (see AddingRepositoriesHowto and remember to do an  apt-get update  afterwards).

Ready?

  • Log into the server console or via ssh, so you can enter commands, and run  sudo -s  to get a root shell.

  • Install some software:

     apt-get install subversion libkrb5-dev attr curl build-essential libssl-dev python-pysqlite2 bzip2 

  • Install some more software:

     apt-get install curl zope3 python-xml python-pyopenssl python-dateutil python-xattr python-pysqlite2 python-twisted python-vobject python-kerberos python-dev 

  • We now need to edit our /etc/fstab file and add  user_xattr  to the options for the partition containing the CalDAV server, / in this case:  vim /etc/fstab  This is what the /etc/fstab change looks like:

     Before: UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro 0 1
    After : UUID=94a96528-c889-45a1-bc98-d9d02ecdd59c / ext3 defaults,errors=remount-ro,user_xattr 0 1 
  • Remount the file system (to activate user_xattr):  mount -o remount / 

  • Create a directory for our server to live in;  mkdir /opt/caldavd 

  • and change into it,  cd /opt/caldavd 

  • Let's download the server software itself using subversion:

     svn checkout http://svn.macosforge.org/repository/calendarserver/CalendarServer/trunk CalendarServer 

  • Subversion has downloaded a lot of software, and created a directory for us, called CalendarServer. Let's change into it:  cd CalendarServer 

  • And run a script to download some necessary packages, configure, etc:  ./run -s 

  • Our CalDAV server is almost ready for action. Let's copy the test configuration so we can get it up as quickly as possible. Real configuration can wait:  cp conf/caldavd-test.plist conf/caldavd-dev.plist 

  • We do need to do a little configuration though:  vi conf/caldavd-dev.plist 

  • First change the hostname for the server. Locate the line  <!-- Network host name -->  and change  <string>localhost</string>  to  <string>your-real-hostname</string>  (That is, put the actual name of your server inside the string, it's used within URLs within the software.)

  • To make the server available to connections from other computers. Locate this line:  <!-- List of IP addresses to bind to [empty = all] -->  and replace  127.0.0.1  in  <string>127.0.0.1</string>  with either nothing or a specific, public ip address for your server.

  • Create a user and group to give our server an identity of its own, but we don't need a home directory for it;  adduser --system --group caldavd --no-create-home 

  • Set permissions;  chown -R caldavd:caldavd /opt/caldavd 

  • Run the server:  sudo -u caldavd -b /opt/caldavd/CalendarServer/run 

That's it! The server is up and running, and you can connect to it with your CalDAV client using  caldav://ADDRESS:8008/calendars/users/admin/calendar  to test the server using username  admin  and password  admin 

To work with Apple iCal under Mac OS 10.5, the URI required was simply:  caldav://ADDRESS:8008 

We want our CalendarServer to start up when our server starts up. Thatfor we write a little startup script:

/etc/init.d/caldavd

. /lib/lsb/init-functions

CALDAVD="/opt/caldavd/CalendarServer/run"
CALDAVD_USER="caldavd"
CALDAVD_OPTS="-d"
PIDFILE="/opt/caldavd/CalendarServer/logs/caldavd.pid"
NAME=caldavd

test -x $CALDAVD || exit 0

case "$1" in
  start)
        log_daemon_msg "Starting Darwin Calendar Server" "$NAME"
        if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --chuid $CALDAVD_USER --exec $CALDAVD -- $CALDAVD_OPTS; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  stop)
        log_daemon_msg "Stopping Darwin Calendar Server" "$NAME"
        if start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  restart)
        log_daemon_msg "Restarting Darwin Calendar Server" "$NAME"
        start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile $PIDFILE
        if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --chuid $CALDAVD_USER --exec $CALDAVD -- $CALDAVD_OPTS; then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
  status)
        status_of_proc -p "$CALDAVD" "$NAME" && exit 0 || exit $?
        ;;
  *)
        log_action_msg "Usage: /etc/init.d/caldavd {start|stop|restart|status}"
        exit 1
esac

exit 0

And to get it to load on boot and shutdown safely:

update-rc.d caldavd defaults

To Do:

We also need to set up users and permissions for the server itself, so people can connect to the server and share their calendars, which is what we've been aiming for.

We should also document where the server-data is stored, so the information that users have entrusted to the server can be backed up.

Ideally we should package this application so the installation is installable with a single command.

CalendarServer/GutsyRecipe (last edited 2011-05-23 21:08:50 by cpc11-cdif12-2-0-cust1)